package PayServer

import (
	"encoding/json"
	"game/base/log"
	"game/base/platApi"
	"game/base/util"
	"game/config"
	"io/ioutil"
	"net/http"
)

func QQPreOrder(w http.ResponseWriter, r *http.Request) {
	var data []byte
	defer func() {
		w.Write(data)
	}()

	if r.Method != "POST" {
		return
	}

	r.ParseForm()
	openid := r.Form.Get("openid")
	zone := r.Form.Get("zone")
	item := r.Form.Get("item")
	amt := r.Form.Get("amt")
	sessionKey := r.Form.Get("sessionKey")
	amount := util.StringToUint32(r.Form.Get("amount"))
	token := platApi.GetAppAccessToken(config.QQAppID, config.QQAppSecret, platApi.Plat_QQ)

	ret, err := platApi.QQPrePay(openid, config.QQAppID, zone, amt, item, amount, token, sessionKey)
	if err != nil {
		log.Error(err)
		return
	}

	data, _ = json.Marshal(ret)
	log.Info("QQPreOrder ret:", ret)
}

func (srv *PayServer) QQPayCallBack(w http.ResponseWriter, r *http.Request) {
	var data []byte
	defer func() {
		w.Write(data)
	}()

	body, e := r.GetBody()
	if e != nil {
		return
	}
	rData, e := ioutil.ReadAll(body)
	if e != nil {
		return
	}

	req := &platApi.QQPayCallBack{}
	err := json.Unmarshal(rData, req)
	if err != nil {
		return
	}

	ok := platApi.QQCallBackVerify(req, r.URL.Path, config.QQAppSecret)
	if !ok {
		return
	}

	ret := &platApi.QQPayCallBackRet{}
	//ret.Code=
	//ret.Msg =

	log.Info("QQPayCallBack ret:", ret, " req:", req)
	data, err = json.Marshal(ret)
	if err != nil {
		return
	}

	//TODO 发货
	//var serverId uint64
	//var uid uint64
	//var id uint32
	//var orderId string
	//msg := &protoMsg.PToL_PaySuccessMsg{
	//	Uid:     uid,
	//	Id:      id,
	//	Channel: common.Pay_QQ,
	//	OrderID: orderId,
	//}
	//srv.Send(serverId, uid, int32(protoMsg.CMD_IN_PToL_PaySuccess), msg)
}
