package PayServer

import (
	"encoding/json"
	"game/base/redis"
	"game/base/util"
	"net/http"
)

func (srv *PayServer) CheckRegisterReward(w http.ResponseWriter, r *http.Request) {
	ret := &SendWeiDuanRewardRet{}
	defer func() {
		ddd, _ := json.Marshal(ret)
		w.Write(ddd)
	}()

	r.ParseForm()
	//sid := r.FormValue("server")
	uid := r.FormValue("uid")
	if redis.HGetUint32("RegisterReward", uid) == 1 {
		ret.Code = 11
		return
	}
	ret.Code = 1
}

func (srv *PayServer) RegisterReward(w http.ResponseWriter, r *http.Request) {
	ret := &SendWeiDuanRewardRet{}
	defer func() {
		ddd, _ := json.Marshal(ret)
		w.Write(ddd)
	}()

	r.ParseForm()
	sid := r.FormValue("server")
	uid := r.FormValue("uid")
	name := r.FormValue("name")
	if redis.HGetUint32("RegisterReward", uid) == 1 {
		ret.Code = 13
		return
	}
	id, _ := util.NextId()
	msg := &MailSenderC2SMsg{
		Id:         id,
		Title:      "新手VIP奖励",
		Content:    "   亲爱的武极天下玩家，感谢您对我们游戏的认可和支持，在此我们将赠予您奖励，期望你在游戏中游玩愉快！",
		Attachment: "10803:6",
		RoleIds:    uid,
		All:        false,
	}

	resp, e := srv.SendMsgToGame(util.StringToInt(sid), "mail/send", msg, name)
	if e != nil {
		ret.Code = 12
		ret.Error = e.Error()
		return
	}
	rr := &MailSenderS2CMsg{}
	json.Unmarshal(resp, rr)
	ret.Code = rr.Code

	if ret.Code == 1 {
		redis.HSet("RegisterReward", uid, 1)
	}
	return
}
