package PayServer

import (
	"encoding/base64"
	"encoding/json"
	"fmt"
	"game/base/platApi"
	"game/base/util"
	"game/config"
	"game/excel"
	"net/url"
	"testing"
	"time"
)

func TestXiaomiPreOrder(t *testing.T) {
	excel.LoadExcel("H:/legend1/design/trunk/数值/data/server")
	ret := &XiaomiPreOrderRet{}
	// 6c19b612e67d86d33780a9213870f694c297591e
	account := "180491490"
	produce := "1"
	session := "C7XU5KjXRI3idYfH"
	uid := "uid"
	sid := "server"

	info := excel.GetPlatformIdById(util.StringToUint32(produce))
	ret.AppAccountID = account
	ret.AppID = config.XiaomiAppID
	ret.Session = session

	ret.CpOrderID = "2563069684353859584"
	ret.CpUserInfo = fmt.Sprintf("%d|%s|%s|%s", time.Now().Unix(), sid, produce, uid)
	ret.DisplayName = info.Name
	ret.FeeValue = info.Money * 100
	values := url.Values{}
	values.Add("appId", ret.AppID)
	values.Add("appAccountId", ret.AppAccountID)
	values.Add("session", ret.Session)
	values.Add("cpOrderId", ret.CpOrderID)
	values.Add("cpUserInfo", "1570708558|16|1|1099511627793")
	values.Add("displayName", ret.DisplayName)
	values.Add("feeValue", util.IntToString(ret.FeeValue))
	ret.Sign = platApi.XiaomiSign(values, config.XiaomiAppPayKey)
	fmt.Printf("%+v", ret)
}

func TestPayServer_XiaomiPayCallBack(t *testing.T) {
	msg := &RechargeCommonC2SMsg{
		RoleId:     68719476740,
		Rmb:        float32(1),
		ChargeYb:   10,
		GiftYb:     0,
		OrderId:    "ssssss",
		POrderId:   "ddddddd",
		PlatformIp: "",
		AttType:    1,
		AttValue:   1,
	}
	d, _ := json.Marshal(msg)
	fmt.Println(string(d))
	fmt.Println(url.PathEscape(string(d)))
}
func TestXiaomiPreOrder2(t *testing.T) {
	//d,_:=util.NextId()
	//s:= fmt.Sprintf("%d|%d|%s|%s",d,1,"1","1290831241")
	//dd:=base64.StdEncoding.EncodeToString([]byte(s))
	//fmt.Println(dd)
	_, e := base64.StdEncoding.DecodeString(config.HuaweiPublicKey)
	fmt.Println(e)

}
