package platApi

import (
	"crypto"
	"crypto/hmac"
	"crypto/rsa"
	"crypto/sha256"
	"crypto/x509"
	"encoding/base64"
	"encoding/hex"
	"fmt"
	"game/config"
	"testing"
)
/*
{
    "openid":"55107C3B8501CD7CBD90AEE4626E6D17",
    "appid":"1107981003",
    "ts":1507530737,
    "zone_id":"1",
    "pf":"qq_m_qq-2001-android-2011",
    "amt":10,
    "goodid":"43",
    "good_num":1,
    "bill_no":"69ae13a3a87f2551109a2ed26bc704201f56d664",
    "app_remark":"xxxxx",
    "sig":"38181bd0acf24eda203655a3be9f2e42b62d4fcf1c1de61a98b0573d13531449"
}
 */
func TestQQPrePay(t *testing.T) {
	//QQPrePay("55107C3B8501CD7CBD90AEE4626E6D17","1107981003","1","10","43",1,"","VUNQZ0hRYURxNlZZbmNOZw==")
	//param:="POST&%2Fapi%2Fjson%2FopenApiPay%2FGamePrePay&amt=10&app_remark=xxxxx&appid=1107981003&bill_no=69ae13a3a87f2551109a2ed26bc704201f56d664&good_nun=1&goodid=43&openid=55107C3B8501CD7CBD90AEE4626E6D17&pf=qq_m_qq-2001-android-2011&ts=1567075139&zone_id=1&session_key=VUNQZ0hRYURxNlZZbmNOZw=="
	param:="POST&%2Fapi%2Fjson%2FopenApiPay%2FGamePrePay&amt=10&app_remark=xxxxx&appid=1107981003&bill_no=69ae13a3a87f2551109a2ed26bc704201f56d664&good_num=1&goodid=43&openid=55107C3B8501CD7CBD90AEE4626E6D17&pf=qq_m_qq-2001-android-2011&ts=1507530737&zone_id=1&session_key=VUNQZ0hRYURxNlZZbmNOZw=="
	k:="VUNQZ0hRYURxNlZZbmNOZw=="

	h1:=hmac.New(sha256.New,[]byte(k))
	h1.Write([]byte(param))
	dd:=h1.Sum(nil)
	fmt.Println(hex.EncodeToString(dd))

}

func TestQQCode2Session(t *testing.T) {


}

func TestOppoCallBackVerify(t *testing.T) {
	cliM := make(map[string]interface{})
	cliM["appKey"] = "k5uz5321wKkWwss0KwO40Os"
	cliM["orderNo"] = "GC201910111511549720100160000"
	cliM["timestamp"] = 1570777914744
	s,e:=oppoSign(cliM,config.OppoPrivateKey)
	fmt.Println(s,e)

	content := fmt.Sprintf("appKey=%s&orderNo=%s&timestamp=%d",
		"k5uz5321wKkWwss0KwO40Os", "GC201910111511549720100160000", 1570777914744)

	sig, err := base64.StdEncoding.DecodeString(s)
	if err != nil {
		return
	}
	kkk:="MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQC7ssiA1OYhgQDVOfG9plHOioqcW2daefuxGJTKfJMMkX/QId8hZ2J2cr97CQgePJ58nTnzwFN2dY3aZ/wu4oGou4l5lmssbbKK1/Lz/8VEVdFfeuT3r5Q5zkZTMCioDCzJOUedEa/NQ+7qe8QSI1I1PXo7lhRIbkGAHHFD451JeQIDAQAB"
	public, _ := base64.StdEncoding.DecodeString(kkk)
	pub, err := x509.ParsePKIXPublicKey(public)
	if err != nil {
		return
	}
	hash := sha256.New()
	hash.Write([]byte(content))
	e= rsa.VerifyPKCS1v15(pub.(*rsa.PublicKey), crypto.SHA256, hash.Sum(nil), sig)
	fmt.Println(e)

}